
//  Include files
#include <uf.h>
#include <uf_exit.h>
#include <uf_ui.h>

#include <uf_assem.h>
#include <uf_abort.h>
#include <uf_cfi.h>
//#include <uf_csys.h>
//#include <uf_curve.h>
//#include <uf_object_types.h>
//#include <uf_facet.h>
#include <uf_part.h>
#include <uf_modl.h>
#include <uf_vec.h>


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <stdarg.h>

#include "marc_main.h"

/**********************************************************************/

#define BUF 128
#define COUNT 1000000

#define UF_CALL(X) (report_error( __FILE__, __LINE__, #X, (X)))

char filename[132];
char filenamelog[132];
char filenametemplate[132];
static const char szFileDat[] = "nastr.dat";
static const char szFileLog[] = "prterr.log";
static const char szFileTemplate[] = "marc.prt";
FILE*	nstr;
FILE*	prterr;

   double		coors[COUNT][3];
   long int		n_pts[COUNT][4];
   long	int		count_pts;


/**********************************************************************/

void DoMarc ( void )
{
 char *ptr;
 char msg[256];
 char words[][20]={
     "COORDINATES",
     "ISOTROPIC",
     "CONNECTIVITY",
     "NO PRINT"
     };
 long int  n_pt, count, delta, pq[4], point[10];
 double c[3];
 char chr;

 int i,j ;
 int k0,k1,k2,alfa;
 int part_namber;

 double A1,B1,C1,A2,B2,C2;
 double tol[3] = {.001,.5*(PI/180),.02};
 double ugol,tmp1;
 double points[9] = { 4.,-2.,0.,
                      4., 4.,0.,
                     -4., 4.,0. };
 char s[25];

 UF_PART_compress_flags_t compress;
 UF_CURVE_line_t line_coords;
// tag_t bpobj;
 tag_t part;
 UF_STRING_t generator;
 UF_STRING_p_t ge = &generator;
// UF_PART_load_status_t load_status;

/*===================================================================================*/
//   

 int status=0;
 UF_CFI_ask_file_exist (filename, &status );
 if (status) {
    msg[0]='\0'; sprintf(msg," %s -   \n  - .",filename);
    uc1601(msg,1);
    return ;
 }

 nstr=fopen(filename,"r");
 if (nstr==NULL) {
    msg[0]='\0'; sprintf(msg," %s -    ..\n  - .",filename);
    uc1601(msg,1);
    return ;
 }

//    -
 ptr=strrchr(filename, '.');
 filenamelog[0]='\0';
 if (ptr) {
    strncpy(filenamelog, filename, ptr-filename);
    filenamelog[ptr-filename]='\0';
    strcat(filenamelog,".log");
   } else {
    //filenamelog[0]='\0'; sprintf(filenamelog,"D:\\%s",szFileLog);
    strcpy(filenamelog,filename);
    strcat(filenamelog,".log");
 }

 prterr=fopen(filenamelog,"w");
 if (prterr==NULL) {
    msg[0]='\0'; sprintf(msg,"!\n  %s -    ..",filenamelog);
    uc1601(msg,1);
    filenamelog[0]='\0'; sprintf(filenamelog,"D:\\%s",szFileLog);
    prterr=fopen(filenamelog,"w");
    if (prterr==NULL) { 
    	msg[0]='\0'; sprintf(msg,"!\n  %s -    ..",filenamelog); 
    	uc1601(msg,1);
    }
 }

/*===================================================================================*/
 //    "COORDINATES"
 do {
   if (NULL==fgets(msg,BUF,nstr)) break;
 } while ( 0!=strncmp(words[0],msg,strlen(words[0])) );
 //  1   COORDINATES
 if (NULL==fgets(msg,BUF,nstr)) {
     fclose(nstr);
     issueError(prterr,-1, "  %s ",words[0]);
     if (prterr!=NULL) fclose(prterr);
     return;
 }

 if (NULL==fgets(msg,BUF,nstr)) {
     fclose(nstr);
     issueError(prterr,-1, "  %s ",words[0]);
     if (prterr!=NULL) fclose(prterr);
     return;
 }
 //  - "ISOTROPIC"
 count=0l;
 do {
    i=sscanf(msg,"%ld%c%le%c%le%c%le",&n_pt,&chr,&c[0],&chr,&c[1],&chr,&c[2]);
    if (i!=7) issueError(prterr,-1, " %s -  (%d)  =%d",words[1],n_pt,i );
    for (i=0; i<3; i++) coors[n_pt][i]=c[i]*1000.0;
    if (NULL==fgets(msg,BUF,nstr)) break;
    count++;
 } while ( 0!=strncmp(words[1],msg,strlen(words[1])) );
 count_pts=count;

 //fseek(nstr, 0L, SEEK_SET);
 rewind(nstr);

 //    "CONNECTIVITY"
 do {
   if (NULL==fgets(msg,BUF,nstr)) break;
 } while ( 0!=strncmp(words[2],msg,strlen(words[2])) );
 //  2  CONNECTIVITY
 for (i=0; i<2; i++) {
   if (NULL==fgets(msg,BUF,nstr)) {
     fclose(nstr);
     issueError(prterr,-1, " %s -  ",words[2] );
     if (prterr!=NULL) fclose(prterr);
     return;
   }
 }

 delta = -1;
 do {
    i=sscanf(msg,"%ld%c%ld%c%ld%c%ld%c%ld%c%ld",&n_pt,&chr,&count,&chr,&pq[0],&chr,&pq[1],&chr,&pq[2],&chr,&pq[3]);
    if (i!=11) issueError(prterr,-1, " %s -  (%d)  =%d",words[3],n_pt,i );
    delta++;
    for (i=0; i<4; i++) n_pts[delta][i]=pq[i];
    if (NULL==fgets(msg,BUF,nstr)) break;
 } while ( 0!=strncmp(words[3],msg,strlen(words[3])) );

  fclose(nstr);
  issueError(prterr,0, "   .." );

/*===================================================================================*/
 part_namber = 1;
 itoa(part_namber,s,10);

 filenametemplate[0]='\0';
 strcpy(filenametemplate, filename);
 ptr=strrchr(filename, '.');
 if (ptr) {
    filenametemplate[0]='\0';
    strncpy(filenametemplate, filename, ptr-filename);
    filenametemplate[ptr-filename]='\0';
 }
 strcat(filenametemplate, s);

/*===================================================================================*/
// UF_PART_save ( );  UF_PART_close_all ( );

  i=UF_PART_new(filenametemplate,1,&part);

//part = UF_ASSEM_ask_work_part();
//UF_ASSEM_add_part_to_assembly

  if ((i!=0)||(part == NULL_TAG))
  {
     msg[0]='\0'; sprintf(msg,"  !\n  %s \n -  ,    ()\n  ...",filenametemplate);
     uc1601(msg,1);
     if (prterr!=NULL) fclose(prterr);
     return;
  }
  /* Continue execution if the part tag is valid. */

  /* Get the compression flag. */
  if(!UF_CALL(UF_PART_ask_compression_flags(part, &compress)))
  {
      if(!compress.standard)
      {
        compress.standard = TRUE;
        UF_CALL(UF_PART_set_compression_flags(part,&compress));
      }
  }

/*===================================================================================*/
//   

/*******************************************/
  UF_ABORT_disable_abort ( );
/*******************************************/

 UF_MODL_create_string_list(1,3,ge);
 ge->string[0] = 3;
 ge->dir[0] = 1;

 k0=0;/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/

 for (i=0; i<delta; i++)
 {
// issueError(prterr,0, "= (%d)",i );
   for (j=i+1; j<delta+1; j++)
   {
    alfa=0;
    for (k1=0; k1<3; k1++)
    {
      for (k2=0; k2<3; k2++)
      {
      	if (n_pts[j][k2]==n_pts[i][k1])
      	{
      	   point[alfa]=n_pts[i][k1];
      	   alfa++;
      	   //issueError(prterr,-10, "= (k1=%d)(k2=%d) = %d  %d ",k1,k2,n_pts[i][k1],n_pts[j][k2] );
      	}
      }
     }

    if (alfa==2)
    {
      //issueError(prterr,-10, "= alfa==2 0=%d  1=%d ",point[0],point[1] );

      A2=coors[n_pts[i][0]][1]*coors[n_pts[i][1]][2]
        +coors[n_pts[i][1]][1]*coors[n_pts[i][2]][2]
        +coors[n_pts[i][2]][1]*coors[n_pts[i][0]][2]
        -coors[n_pts[i][0]][1]*coors[n_pts[i][2]][2]
        -coors[n_pts[i][1]][1]*coors[n_pts[i][0]][2]
        -coors[n_pts[i][2]][1]*coors[n_pts[i][1]][2];

      B2=coors[n_pts[i][0]][0]*coors[n_pts[i][2]][2]
        +coors[n_pts[i][1]][0]*coors[n_pts[i][0]][2]
        +coors[n_pts[i][2]][0]*coors[n_pts[i][1]][2]
        -coors[n_pts[i][0]][0]*coors[n_pts[i][1]][2]
        -coors[n_pts[i][1]][0]*coors[n_pts[i][2]][2]
        -coors[n_pts[i][2]][0]*coors[n_pts[i][0]][2];

      C2=coors[n_pts[i][0]][0]*coors[n_pts[i][1]][1]
        +coors[n_pts[i][1]][0]*coors[n_pts[i][2]][1]
        +coors[n_pts[i][2]][0]*coors[n_pts[i][0]][1]
        -coors[n_pts[i][0]][0]*coors[n_pts[i][2]][1]
        -coors[n_pts[i][1]][0]*coors[n_pts[i][0]][1]
        -coors[n_pts[i][2]][0]*coors[n_pts[i][1]][1];

      A1=coors[n_pts[j][0]][1]*coors[n_pts[j][1]][2]
        +coors[n_pts[j][1]][1]*coors[n_pts[j][2]][2]
        +coors[n_pts[j][2]][1]*coors[n_pts[j][0]][2]
        -coors[n_pts[j][0]][1]*coors[n_pts[j][2]][2]
        -coors[n_pts[j][1]][1]*coors[n_pts[j][0]][2]
        -coors[n_pts[j][2]][1]*coors[n_pts[j][1]][2];

      B1=coors[n_pts[j][0]][0]*coors[n_pts[j][2]][2]
        +coors[n_pts[j][1]][0]*coors[n_pts[j][0]][2]
        +coors[n_pts[j][2]][0]*coors[n_pts[j][1]][2]
        -coors[n_pts[j][0]][0]*coors[n_pts[j][1]][2]
        -coors[n_pts[j][1]][0]*coors[n_pts[j][2]][2]
        -coors[n_pts[j][2]][0]*coors[n_pts[j][0]][2];

      C1=coors[n_pts[j][0]][0]*coors[n_pts[j][1]][1]
        +coors[n_pts[j][1]][0]*coors[n_pts[j][2]][1]
        +coors[n_pts[j][2]][0]*coors[n_pts[j][0]][1]
        -coors[n_pts[j][0]][0]*coors[n_pts[j][2]][1]
        -coors[n_pts[j][1]][0]*coors[n_pts[j][0]][1]
        -coors[n_pts[j][2]][0]*coors[n_pts[j][1]][1];

      //issueError(prterr,0, "= A1=%8.3lf,A2=%8.3lf,B1=%8.3lf,B2=%8.3lf,C1=%8.3lf,C2=%8.3lf ",A1,A2,B1,B2,C1,C2 );

      tmp1=sqrt(A1*A1+B1*B1+C1*C1)*sqrt(A2*A2+B2*B2+C2*C2);
      if (fabs(tmp1)>0.0000001) ugol=acos((A1*A2+B1*B2+C1*C2)/tmp1); else ugol=PI/2.0;
      //issueError(prterr,0, "= ugol=%8.3lf",ugol );
      if (ugol>(PI/18))
      {
      	UF_VEC3_copy (&coors[point[0]][0], line_coords.start_point );
      	UF_VEC3_copy (&coors[point[1]][0], line_coords.end_point );
      	UF_CURVE_create_line(&line_coords,&ge->id[k0]);
      }

     }

    }
   }

/*
    for (k0=0; k0<3; k0++)
    {
	UF_VEC3_copy (&coors[n_pts[i][k0]][0], line_coords.start_point );
	UF_VEC3_copy (&coors[n_pts[i][k0+1]][0], line_coords.end_point );
	UF_CURVE_create_line(&line_coords,&ge->id[k0]);
     }
*/
//  UF_MODL_create_bplane(ge,tol,&bpobj);
/*
    UF_PART_save ( );
    UF_PART_close_all ( );
*/
/*
  delta = 1;
  part_namber = 11;
  do {
   strcpy(s1, "e:\\marc_part\\part");
   itoa(delta,s,10);
   strcat(s1, s);
   UF_PART_open (s1,&part,&load_status);
   delta++;
  } while (delta<part_namber+1);
*/

/*******************************************/
  UF_ABORT_enable_abort ( );
/*******************************************/

/*===================================================================================*/

  issueError(prterr,0, " ...");
  if (prterr!=NULL) fclose(prterr);

  return ;
}


/*======================================================================*/
static int report_error( char *file, int line, char *call, int irc)
{
    if (irc)
    {
        char err[133], msg[133];

        sprintf(msg, "*** ERROR code %d at line %d in %s:\n", irc, line, file);
        UF_get_fail_message(irc, err);

        UF_print_syslog(msg, FALSE);
        UF_print_syslog(err, FALSE);
        UF_print_syslog("\n", FALSE);
        UF_print_syslog(call, FALSE);
        UF_print_syslog(";\n", FALSE);

        if (!UF_UI_open_listing_window())
        {
            UF_UI_write_listing_window(msg);
            UF_UI_write_listing_window(err);
            UF_UI_write_listing_window("\n");
            UF_UI_write_listing_window(call);
            UF_UI_write_listing_window(";\n");
        }
    }

    return(irc);
}


/*======================================================================================*/
int issueError (FILE * log_file,int ecode, char *format, ... )
{
   va_list   ap;
   char      buffer[256];buffer[0]='\0';

   va_start( ap, format );
   if( ecode != 0 )
   {
     if (log_file!=NULL) fprintf( log_file, "Error %d: %s\n", ecode, buffer );
      else printf( "Error %d: %s\n", ecode, buffer );
   }
   if (log_file!=NULL) vfprintf( log_file, format, ap );
    else vprintf( format, ap );
   va_end( ap );
   return(0);
}


/*======================================================================*/
int Marc_ui_mgr(void)
{
  int response ;
  char menu_main[14][38];

  int module_id;
  UF_ask_application_module(&module_id);
  if (UF_APP_MODELING!=module_id) {
     // UF_APP_GATEWAY UF_APP_MECHANISMS  UF_APP_MODELING UF_APP_ICAD UF_APP_NONE
     uc1601(" DLL -    MODELING\n .,  - 2005.",1);
  }

  UF_UI_display_nonmodal_msg (" :", " .,  - 2005.\n( Taimael@yandex.ru )", UF_UI_MSG_POS_TOP_LEFT );

  filename[0]='\0'; sprintf(filename,"D:\\%s",szFileDat);
  filenamelog[0]='\0'; sprintf(filenamelog,"D:\\%s",szFileLog);
  filenametemplate[0]='\0'; sprintf(filenametemplate,"D:\\%s",szFileTemplate);

  strcpy(&menu_main[0][0], "->    .\0");
  strcpy(&menu_main[1][0], "-> ->\0");
  strcpy(&menu_main[2][0], "->  .\0");

  response=3;
  while (response != 1 && response != 2  && response != 19 )
  {

   response = uc1603(" .....",1,menu_main, 2+1);

   if (response >= 3 || response < 19 )
   {
     switch (response)
     {
	case 5 ://   
	Marc_ui_file();
	break ;
	case 6 ://  
	DoMarc ();
	break ;
	case 7 ://    help
	Marc_ui_help();
	break ;
	default : break ;
      }
   }

  } // end while uc1603

 return(0);
}


/*======================================================================*/
int Marc_ui_file(void)
{

   char filter_string[132] = "*.dat";
   int response = 0;
   int rc = 0;
   char msg[132];

   rc = UF_UI_create_filebox ("   ..",
                              "   ..",
                              filter_string,
                              (char *)szFileDat,
                              filename,
                              &response);
   if(rc)
   {
        /* Print out the message */
        UF_get_fail_message(rc, msg);
        UF_UI_set_status( msg );
   }

   return(response);
}


/*======================================================================*/
int Marc_ui_help(void)
{
  int response;
  char menu[1][38];
  char *release;
  long t1 ;
  char mes[256] ;

  UF_UI_open_listing_window();

  UF_get_release (&release );
  mes[0]='\0'; sprintf(mes,"\n  Unigraphics - %s \n",release); UF_UI_write_listing_window(mes);

  time(&t1);
  mes[0]='\0'; sprintf(mes,"\n : %s ",ctime(&t1)); UF_UI_write_listing_window(mes);

  mes[0]='\0'; sprintf(mes,"\n      ."); UF_UI_write_listing_window(mes);

  mes[0]='\0'; sprintf(mes,"\n :"); UF_UI_write_listing_window(mes);
  mes[0]='\0'; sprintf(mes,"\n\t  .(,  ,),-- - 2005."); UF_UI_write_listing_window(mes);
  mes[0]='\0'; sprintf(mes,"\n\t  (,-,),-- - 2006.\n"); UF_UI_write_listing_window(mes);

  UF_UI_write_listing_window("\n#============================================================");

  mes[0]='\0'; sprintf(mes,"\n  : %s ",filename); UF_UI_write_listing_window(mes);
  mes[0]='\0'; sprintf(mes,"\n    : %s ",filenamelog); UF_UI_write_listing_window(mes);
  mes[0]='\0'; sprintf(mes,"\n  Prt  : %s ",filenametemplate); UF_UI_write_listing_window(mes);

  UF_UI_write_listing_window("\n#============================================================");

UF_UI_write_listing_window("\n");
UF_UI_write_listing_window("\n\t   :");
UF_UI_write_listing_window("\n 1)   ");
UF_UI_write_listing_window("\n 2)   \"\" ");
UF_UI_write_listing_window("\n ");
UF_UI_write_listing_window("\n");
UF_UI_write_listing_window("\n\t  Unigraphics -  ");
UF_UI_write_listing_window("\n ");
UF_UI_write_listing_window("\n ");
UF_UI_write_listing_window("\n");
UF_UI_write_listing_window("\n   :");
UF_UI_write_listing_window("\n 	......");
UF_UI_write_listing_window("\n 	......");
UF_UI_write_listing_window("\n 	......");
UF_UI_write_listing_window("\n 	......");
UF_UI_write_listing_window("\n 	......");
UF_UI_write_listing_window("\n");
UF_UI_write_listing_window("\n         :");

UF_UI_write_listing_window("\n#============================================================\n");

  UF_UI_write_listing_window("\n\t \"    'marc' Unigraphics\"");
  UF_UI_write_listing_window("\n\t  ;");
  UF_UI_write_listing_window("\n\t  ;");
  UF_UI_write_listing_window("\n\t  ;");
  UF_UI_write_listing_window("\n\t  ;");

  UF_UI_write_listing_window("\n#============================================================\n$$");

  strcpy(&menu[0][0], "\0");

  response=3;
  while (response == 3 || response == 4) {
    response = uc1603("      ..",1,menu, 0+1);
  }

  //UF_UI_close_listing_window () ;

  return(0);

}

